//  HyperCell.h
//
//  a simple cell subclass that can be placed into a text object
//  plus hypertext abilities
//
//	(c) TBL,CERN 1994
//
#import <appkit/appkit.h>
#import "HyperText.h"
#import "libwww.h"

@interface HyperCell:Cell
{
	int			element_number;	// SGML index
	CONST SGML_dtd *	dtd;
	BOOL*			present;	// and attributes
	char * *		value;
	
	HTChildAnchor * 	linkAnchor;	// May be part of anchor
	HyperText * 		view;		// Containing view
}

// - setFile:(const char *)theFile;
// - calcCellSize:(NXSize *)theSize;
// - drawSelf:(const NXRect *)rect inView:view;
// - highlight:(const NXRect *)rect inView:view lit:(BOOL)flag;
+ new;
- readRichText:(NXStream *)stream forView:view ;
- writeRichText:(NXStream *)stream forView:view;
- (BOOL)trackMouse:(NXEvent *)theEvent inRect:(const NXRect *)rect ofView:view;
- initForElement: (int)ele
	inDTD: (CONST SGML_dtd*) dtd
	attributesPresent:(BOOL*)pres
	withValues:(char**)val
	inView: (HyperText *) view;
- writeSGML:(HTStructured *) thisTarget relativeTo:(const char *)aName;
- setup;				// Initialise from instance vars			

- (HTChildAnchor*) linkAnchor;
- setLinkAnchor: (HTChildAnchor*) anc;

@end
