/*
 *     Generated by the NeXT Interface Builder.
 * 
 * History:
 *	27 Feb 91	Modified TBL to initialise NXArgv early on
 *	19 Mar 91	Page info deafults
 *
 *	(c) Tim Berners-Lee.  Mail all mods to timbl@info.cern.ch
*/

#import <stdlib.h>
#import <appkit/appkit.h>
// #import <appkit/defaults.h>			/* TBL */
#import "libwww.h"				/* TBL */
#import <string.h>				/* TBL */
#import <libc.h>				/* TBL */
/* #import <appkit/PrintInfo.h>		*/	/* TBL */
/* #import <defaults/defaults.h>	*/		/* TBL */
#import "imageReps.subproj/GifImageRep.h" 	/* TBL */

extern char * appDirectory;	/* Name of the directory containing the application */
extern char * MyIconRoot;	/* in manager */

/*	Get Integer default value
*/
static int int_default(const char * param)
{
    int	result = 0;
    const char * string = NXGetDefaultValue("WorldWideWeb", param);
    if (string) sscanf(string, "%i", &result);
    return result;
}

char * log_file_name = NULL;		/* for WAIS code */

char * HTAppVersion = "1.1";
char * HTAppName = "CERN-NextStep-WorldWideWeb.app";

extern BOOL HTMultiWindowMode;		/* In HyperText.m */


void malloc_report(int problem)
{
    fprintf(stderr, "Malloc error report: error %i. Crashing.\n", problem);
    return ;
}

///////////////////////////////////////////////////////////////////////////

void main(int argc, char *argv[])
{
//    NXArgc = argc;		/* TBL */
//    NXArgv = argv;		/* TBL */

    char *p;
    
    static NXDefaultsVector myDefaults = {
        { "PaperType", "Letter"},		// Non-USA users will have to override
	{ "LeftMargin", "72"},			//  (72) Space for ring binding
	{ "RightMargin", "36"},			//  (72) Note printers need some margin 
	{ "TopMargin", "36"},			// (108) All margins in points
	{ "BottomMargin", "36"},		// (108) PrintInfo defaults in brackets
	{ "MallocDebug", "0" },			//  Debug level for malloc
	{ "Trace", "NO" },			//  Trace WWW activity?
	{ "MultiWindow", "NO" },
	{ NULL, NULL}				// Terminate list.
    };
    
//	Where are we? 
    
    appDirectory = malloc(strlen(argv[0]));
    strcpy(appDirectory, argv[0]);
    if (p = strrchr(appDirectory, '/')) p[1]=0;	/* Chop home directory after slash */
    if (TRACE) printf("WWW: Run from %s\n", appDirectory);

//	Deduce where the icons are
    {
        char file_prefix[] = "file:";
	char * icon_subdir = "/";
        char* icon_dir =malloc(
		strlen(file_prefix)
		+strlen(appDirectory)+strlen(icon_subdir)+1);
	strcpy(icon_dir, appDirectory);
	strcat(icon_dir, icon_subdir);
	
    	HTStdIconInit(icon_dir);
	StrAllocCopy(MyIconRoot, icon_dir);
	free(icon_dir);
    }
    
    HTMLUseCharacterSet(HTML_NEXT_CHARS);  /* select internal repn */
    
    NXApp = [Application new];
    NXRegisterDefaults("WorldWideWeb", myDefaults);
    
  [NXImage registerImageRep:[GifImageRep class]];  /* Add GIF cabability */
    
    [NXApp loadNibSection:"WorldWideWeb.nib" owner:NXApp];

//	The deafult Margins seem to be 72, 72, 108, 108 which is a lot.    
    {
	int leftM = int_default("LeftMargin");
	int rightM = int_default("RightMargin");
	int topM = int_default("TopMargin");
	int bottomM = int_default("BottomMargin");
	
        PrintInfo * pi = [NXApp printInfo];
        [pi setPaperType:NXGetDefaultValue("WorldWideWeb", "PaperType") andAdjust:YES];
	[pi setVertCentered:NO];
	[pi setMarginLeft:leftM right:rightM top:topM bottom:bottomM]; // Points.
    }
    
    if (!strcasecomp("YES", NXGetDefaultValue("WorldWideWeb", "MultiWindow"))) {
	HTMultiWindowMode = 1;
    }
    
//	Set trace levels

    if (!strcasecomp("YES", NXGetDefaultValue("WorldWideWeb", "Trace"))) {
    	WWW_TraceFlag = 1;
	fprintf(stderr, "main: WWW trace turned on by NeXT default `Trace'\n"); 
    }
    
    {
        int new = atoi(NXGetDefaultValue("WorldWideWeb", "MallocDebug"));
	int old = malloc_debug(new);
	if (old != new) fprintf(stderr,
	    "MallocDebug set from %d to %d by NeXT default `MallocDebug'\n", old, new);
	if (new > 1) {
	    malloc_error(malloc_report); // Set report routine!
	}
    }


    
//	Actually run the application

    [NXApp run];
    [NXApp free];
    exit(0);
}
